//+------------------------------------------------------------------+
//|                                                         Pv-2.mq4 |
//|                                                          |
//|                                                Skype privalov-sv |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "Skype privalov-sv"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_width1  2

#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft); 
#import
extern   int    n      = 5;    //  - 
extern   int    hmax      = 1; 
//---- indicator buffers
double     MacdBuffer[];
double     SignalBuffer[];
//Global variables
int N;                  //N is number of data points.

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   N=MathPow(2,n);
   if(hmax>N) hmax=N;   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
//   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+Digits);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Pv-2("+n+","+hmax+")");
   SetIndexLabel(0,"Energi");
   SetIndexLabel(1,"Shum");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   double  porog;
   double data[],data1[],energi_sign,energi_shum;
   ArrayResize(data,N);
   ArrayResize(data1,N);
   
//---- last counted bar will be recounted
   if (counted_bars==0)   limit=Bars-1; //    ,     
   if (counted_bars>0)   limit=Bars-counted_bars-1; //       
   //     
   for(int j=limit;j>=0;j--)
      {
      for(int i=0;i<N;i++) data[i]=Close[i];
      realfastfouriertransform(data,N,false);   //   CLOSE  
      energi_sign=0; //  
      energi_shum=0;
      ArrayCopy(data1,data);                    //   ,    
      ArraySort(data1,WHOLE_ARRAY,0,MODE_DESCEND); //  
      porog=data1[hmax];      //   

      //   
      for(i=hmax;i<N;i++)
         {
         if (data[i]<porog)      //   
            {
            //    ->  
            energi_sign=energi_sign+data[i];
            }
         else
            {
            //    ->  
            energi_shum=energi_shum+data[i];
            }
        }
      MacdBuffer[j]=energi_sign;//   
      SignalBuffer[j]=energi_shum;
      }
   return(0);
  }
//+------------------------------------------------------------------+